import py_trees
import asyncio
from .constants import *
from rocon_client_sdk_py.core_logic.context import Context
from rocon_client_sdk_py.logger.rocon_logger import rocon_logger
from rocon_client_sdk_py.utils.util import *

class TaskBase(py_trees.behaviour.Behaviour):
    def __init__(self, name="NoNamed"):
        super(TaskBase, self).__init__(name)
        self.rocon_logger = rocon_logger

    @property
    def context(self) -> Context:
        blackboard = py_trees.blackboard.Client(name=MASTER_BLACKBOARD_NAME)
        blackboard.register_key(key=KEY_CONTEXT, access=py_trees.common.Access.READ)
        value = blackboard.get(KEY_CONTEXT)
        return value

    @asyncio.coroutine
    def bug(self):
        raise Exception('not consumed')

    def check_valid_interval(self, req_interval_ms, last_updated_ms):
        '''
        마지막 업데이트된 시간과 현재 시간 갭이 주어진 req_interval 보다 같거나 크면 True 리턴, 그렇지 않으면 False 리턴
        :param req_interval: ms
        :param last_updated_at: ms
        :return:
        '''
        curnt_time_ms = get_time_milliseconds(current_datetime_utc_iso_format())
        gap = curnt_time_ms - last_updated_ms

        if gap < req_interval_ms:
            return False

        return True


class Task(TaskBase):
    def __init__(self, name="Task NoNamed"):
        super(Task, self).__init__(name)


class AsyncTask(TaskBase):
    def __init__(self, name="AsyncTask NoNamed"):
        super(AsyncTask, self).__init__(name)

        self.async_task_status = py_trees.common.Status.INVALID
