from .api import Api


class ApiSiteConfiguration(Api):

    @property
    def hostname(self):
        return self._httpclient.hostname_site_config

    async def get_zones(self, zone_type, map_id):
        query = {'map':map_id, 'type':zone_type}
        request = self._httpclient.request()
        url = self._httpclient.site_config_url('/api/zones')
        self.rocon_logger.debug('request.post > {}'.format(url))

        try:
            async with request.get(url, params=query) as r:
                self.rocon_logger.debug('response status > {}'.format(r.status))
                json_data = await r.json()
                self.rocon_logger.debug('response data > \n{}'.format(json_data))
                return json_data

        except Exception as exc:
            self.rocon_logger.error(exc)
            return None
