from .api import Api


class ApiWorkerPool(Api):

    @property
    def hostname(self):
        return self._httpclient.hostname_worker_pool

    async def register_worker(self, worker_id, reg_data):
        request = self._httpclient.request()
        url = self._httpclient.worker_pool_url('/api/workers/{}/register/'.format(worker_id))
        self.rocon_logger.debug('request.post > {}'.format(url))

        try:
            async with request.post(url, json=reg_data) as r:

                self.rocon_logger.debug('response status > {}'.format(r.status))
                json_data = await r.json()
                self.rocon_logger.debug('response data > \n{}'.format(json_data))
                return json_data

        except Exception as exc:
            self.rocon_logger.error(exc)
            return None