import pydash
import os
from .worker import Worker


class VirtualWorker(Worker):

    def __init__(self, uuid, client_configs, event_loop, working_root, hooks_def_path=None, acts_def_path=None, msgs_def_path=None):

        # 경로 재정의
        dir_path = os.path.dirname(os.path.realpath(__file__))
        hooks_def_path = dir_path + '/virtual_core/hooks'
        acts_def_path = dir_path + '/virtual_core/actions'
        msgs_def_path = dir_path + '/virtual_core/messages'

        super().__init__(uuid, client_configs, event_loop, working_root, hooks_def_path, acts_def_path, msgs_def_path)

    async def on_hook(self, context, hook, hook_body):
        return await hook.on_handle(context, hook_body)

    async def on_message(self, context, message, message_body):
        return await message.on_handle(context, message_body)

    async def on_pre_process_instructions(self, context, instructions):
        pass

    async def on_process_instruction(self, context, action, args):
        return await action.on_perform(context, args)

    async def on_post_process_instructions(self, context, instructions, is_success):
        pass

    async def on_check_offline_status(self, context, current_status):
        pass

    async def on_check_error_status(self, context, current_status):
        pass

    async def get_dev_path_finding_map(self):
        return